<script>
  import Upload from "./lib/Upload.svelte";
  import Categories from "./lib/Categories.svelte";
  import { convert } from "./api/convert";
  let categories = [];
  let lines = [];

  $: console.log("categories", categories);

  const onUpload = async (file) => {
    lines = await convert(file);
  };

  const onAdd = (category) => {
    categories = [...categories, category];
  };

  const getWordCategory = (word) =>
    categories.find((category) =>
      category.words
        .map((word) => word.toLowerCase())
        .includes(word.toLowerCase()),
    );

  const getWordStyle = (word) => {
    const category = getWordCategory(word);
    let styleString = "";

    if (!!category) {
      styleString = `color: ${category.color}`;
    }

    return styleString;
  };
</script>

<main class="main-body">
  <Upload {onUpload} />
  <Categories {onAdd} />
  <div>
    {#each lines as line}
      <div>
        {#each line as word, index}
          <span
            class={index !== 0 ? "spaced-line" : ""}
            style={getWordStyle(word)}>{word}</span
          >
        {/each}
      </div>
      <br />
    {/each}
  </div>
</main>

<style>
  .main-body {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    height: 100%;
  }
  .spaced-line {
    margin-left: 1ch;
  }
</style>
